routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('main');
});

Route::get('/member/login', [ MemberController::class, 'login' ] );

Route::get('/member/register', [ MemberController::class, 'register' ] );

Route::get('/member', [ MemberController::class, 'index' ]);

Route::get('/member/profile', [ MemberController::class, 'profile' ]);

Route::get('/dashboard', [ 
	MemberController::class,
	'index'])
	->name('dashbaord')
	->middleware(['auth']);


Route::middleware(['auth', 'can:is-admin'])->group(function(){

	Route::resource('admin/user', UserController::class);
	Route::resource('admin/role', RoleController::class);
	Route::resource('admin/plan', PlanController::class);
	
});

Route::get('/signup', [ SignUpController::class, 'index' ]);
Route::get('/signup/review/{id}', [ SignUpController::class, 'review' ]);
Route::post('/signup/go/{payment_gateway}', [ SignUpController::class, 'go' ])->name('signup.go');

Route::post('/signup/thankyou/{payment_gateway}', [ SignUpController::class, 'thankyou' ])->name('signup.thankyou');
Route::get('/signup/thankyou/{payment_gateway}', [ SignUpController::class, 'thankyou' ]);

app/Models/Plan.php
<?php

namespace App\Models;

use Illuminate\Support\Str;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;

class Plan extends Model
{
    use HasFactory;

    protected $fillable = [
        'name',
        'price',
        'duration',
    ];

    public function getMoneyPriceAttribute()
    {   
        return 'RM '.number_format( ($this->price / 100), 2 );
    }

    public function setNameAttribute($value)
    {
        $this->attributes['name'] = Str::title($value);
    }
    
}

app/Http/Controllers/PlanController.php
<?php

namespace App\Http\Controllers;

use App\Models\Plan;
use Illuminate\Http\Request;

class PlanController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $plans = Plan::all();
        return view('admin.plan.index', [ 'plans' => $plans ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.plan.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $data = $request->validate([
            'name' => 'required|min:5|max:100',
            'price' => 'required|numeric',
            'duration' => 'required|integer',
        ]);

        $data['price'] = abs(floor($data['price'] * 100));

        $plan = Plan::create($data);

        return redirect('/admin/plan')->with('success',"Pelan langganan <b>{$plan->name} ({$plan->id})</b> telah berjaya disimpan.");
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/admin/plan/create.blade.php
@extends('layout.private') 

@section('content')

    <h1 class="h3 mb-3 text-gray-800">Tambah Pelan Baru</h1>

    <div class="card shadow mb-4">
    <div class="card-header py-3">
        <h6 class="m-0 font-weight-bold text-primary">Isikan maklumat untuk pelan langganan baru</h6>
    </div>
    <div class="card-body">

        <form action="{{ route('plan.store') }}" method="post">
            @csrf

            <div class="mb-3 row">
                <label class="col-sm-2 col-form-label">Nama</label>
                <div class="col-sm-10">
                    <input type="text" class="form-control @error('name') is-invalid @enderror" name="name" value="{{ old( 'name' ) }}">
                    @error('name')
                    <div class="invalid-feedback">{{$message}}</div>
                    @enderror
                </div>
            </div>

            <div class="mb-3 row">
                <label class="col-sm-2 col-form-label">Harga</label>
                <div class="col-sm-10">
                    <input type="number" 
                    min="1"
                    max="99999"
                    step="0.01"
                    class="form-control @error('price') is-invalid @enderror" 
                    name="price" value="{{ old( 'price' ) }}">
                    @error('price')
                    <div class="invalid-feedback">{{$message}}</div>
                    @enderror
                </div>
            </div>

            <div class="mb-3 row">
                <label class="col-sm-2 col-form-label">Tempoh</label>
                <div class="col-sm-10">
                    <input type="number" 
                    min="1"
                    max="99999"
                    step="1"
                    class="form-control @error('duration') is-invalid @enderror" 
                    name="duration" value="{{ old( 'duration' ) }}">
                    @error('duration')
                    <div class="invalid-feedback">{{$message}}</div>
                    @enderror
                </div>
            </div>


            <a href="/admin/plan" class="btn btn-secondary btn-lg">Batal</a>

            <button type="submit" class="btn btn-lg btn-primary">Simpan</button>

        </form>

    </div>
</div>

@endsection 

resources/views/admin/plan/index.blade.php
@extends('layout.private')


@section('content')
<div class="d-flex justify-content-between mb-3">
    <h1 class="h3 mb-2 text-gray-800">Senarai Pelan Langganan</h1>

    <a href="/admin/plan/create" class="btn btn-secondary">Tambah Pelan</a>
</div>


@if( session('success') ) 
    <div class="alert alert-success">{!! session('success') !!}</div>
@endif

<div class="card shadow mb-4">
    <div class="card-header py-3">
        <h6 class="m-0 font-weight-bold text-primary">Senarai Pelan Langganan</h6>
    </div>
    <div class="card-body">
        <table class="table table-stripe">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>NAMA</th>
                    <th>HARGA</th>
                    <th>TEMPOH</th>
                    <th></th>
                </tr>
            </thead>
            <tbody>


                @forelse($plans as $plan)
                <tr>
                    <td>{{$plan->id}}</td>
                    <td>{{$plan->name}}</td>
                    <td>{{ $plan->money_price }}</td>
                    <td>{{$plan->duration}}</td>
                    <td>
                        <a href="{{ route('plan.edit', $plan->id) }}" class="btn btn-sm btn-primary">EDIT</a>
                
                        <form method="post" class="d-inline" 
                        action="{{ route('plan.destroy', $plan->id) }}"
                        onsubmit="return confirm('Are you sure you want to delete {{$plan->name}} ({{$plan->id}})?');" >
                            @csrf 
                            @method('DELETE')
                            <button type="submit" class="btn btn-danger btn-sm">DELETE</button>
                        </form>
                    </td>
                </tr>
                @empty 
                <tr>
                        <td colspan="5" class="text-center" style="height: 50px;">
                            anda belum membuat apa-apa pelan langganan
                        </td>
                    </tr>

                @endforelse
            </tbody>

        </table>
    </div>
</div>



@endsection 